Index: t3lib/class.t3lib_befunc.php
===================================================================
--- t3lib/class.t3lib_befunc.php	(revision 9522)
+++ t3lib/class.t3lib_befunc.php	(revision )
@@ -1,29 +1,29 @@
 <?php
 /***************************************************************
-*  Copyright notice
-*
-*  (c) 1999-2010 Kasper Skårhøj (kasperYYYY@typo3.com)
-*  All rights reserved
-*
-*  This script is part of the TYPO3 project. The TYPO3 project is
-*  free software; you can redistribute it and/or modify
-*  it under the terms of the GNU General Public License as published by
-*  the Free Software Foundation; either version 2 of the License, or
-*  (at your option) any later version.
-*
-*  The GNU General Public License can be found at
-*  http://www.gnu.org/copyleft/gpl.html.
-*  A copy is found in the textfile GPL.txt and important notices to the license
-*  from the author is found in LICENSE.txt distributed with these scripts.
-*
-*
-*  This script is distributed in the hope that it will be useful,
-*  but WITHOUT ANY WARRANTY; without even the implied warranty of
-*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-*  GNU General Public License for more details.
-*
-*  This copyright notice MUST APPEAR in all copies of the script!
-***************************************************************/
+ *  Copyright notice
+ *
+ *  (c) 1999-2010 Kasper Skårhøj (kasperYYYY@typo3.com)
+ *  All rights reserved
+ *
+ *  This script is part of the TYPO3 project. The TYPO3 project is
+ *  free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  The GNU General Public License can be found at
+ *  http://www.gnu.org/copyleft/gpl.html.
+ *  A copy is found in the textfile GPL.txt and important notices to the license
+ *  from the author is found in LICENSE.txt distributed with these scripts.
+ *
+ *
+ *  This script is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  This copyright notice MUST APPEAR in all copies of the script!
+ ***************************************************************/
 /**
  * Standard functions available for the TYPO3 backend.
  * You are encouraged to use this class in your own applications (Backend Modules)
@@ -45,126 +45,126 @@
  *
  *  185: class t3lib_BEfunc
  *
- *              SECTION: SQL-related, selecting records, searching
+ *			  SECTION: SQL-related, selecting records, searching
- *  206:     function deleteClause($table,$tableAlias='')
+ *  206:	 function deleteClause($table,$tableAlias='')
- *  230:     function getRecord($table,$uid,$fields='*',$where='',$useDeleteClause=true)
+ *  230:	 function getRecord($table,$uid,$fields='*',$where='',$useDeleteClause=true)
- *  253:     function getRecordWSOL($table,$uid,$fields='*',$where='',$useDeleteClause=true)
+ *  253:	 function getRecordWSOL($table,$uid,$fields='*',$where='',$useDeleteClause=true)
- *  286:     function getRecordRaw($table,$where='',$fields='*')
+ *  286:	 function getRecordRaw($table,$where='',$fields='*')
- *  309:     function getRecordsByField($theTable,$theField,$theValue,$whereClause='',$groupBy='',$orderBy='',$limit='',$useDeleteClause=true)
+ *  309:	 function getRecordsByField($theTable,$theField,$theValue,$whereClause='',$groupBy='',$orderBy='',$limit='',$useDeleteClause=true)
- *  342:     function searchQuery($searchWords,$fields,$table='')
+ *  342:	 function searchQuery($searchWords,$fields,$table='')
- *  357:     function listQuery($field,$value)
+ *  357:	 function listQuery($field,$value)
- *  369:     function splitTable_Uid($str)
+ *  369:	 function splitTable_Uid($str)
- *  384:     function getSQLselectableList($in_list,$tablename,$default_tablename)
+ *  384:	 function getSQLselectableList($in_list,$tablename,$default_tablename)
- *  412:     function BEenableFields($table,$inv=0)
+ *  412:	 function BEenableFields($table,$inv=0)
  *
- *              SECTION: SQL-related, DEPRECATED functions
+ *			  SECTION: SQL-related, DEPRECATED functions
- *  476:     function mm_query($select,$local_table,$mm_table,$foreign_table,$whereClause='',$groupBy='',$orderBy='',$limit='')
+ *  476:	 function mm_query($select,$local_table,$mm_table,$foreign_table,$whereClause='',$groupBy='',$orderBy='',$limit='')
- *  498:     function DBcompileInsert($table,$fields_values)
+ *  498:	 function DBcompileInsert($table,$fields_values)
- *  512:     function DBcompileUpdate($table,$where,$fields_values)
+ *  512:	 function DBcompileUpdate($table,$where,$fields_values)
  *
- *              SECTION: Page tree, TCA related
+ *			  SECTION: Page tree, TCA related
- *  542:     function BEgetRootLine($uid,$clause='',$workspaceOL=FALSE)
+ *  542:	 function BEgetRootLine($uid,$clause='',$workspaceOL=FALSE)
- *  598:     function openPageTree($pid,$clearExpansion)
+ *  598:	 function openPageTree($pid,$clearExpansion)
- *  643:     function getRecordPath($uid, $clause, $titleLimit, $fullTitleLimit=0)
+ *  643:	 function getRecordPath($uid, $clause, $titleLimit, $fullTitleLimit=0)
- *  686:     function getExcludeFields()
+ *  686:	 function getExcludeFields()
- *  716:     function getExplicitAuthFieldValues()
+ *  716:	 function getExplicitAuthFieldValues()
- *  787:     function getSystemLanguages()
+ *  787:	 function getSystemLanguages()
- *  812:     function readPageAccess($id,$perms_clause)
+ *  812:	 function readPageAccess($id,$perms_clause)
- *  843:     function getTCAtypes($table,$rec,$useFieldNameAsKey=0)
+ *  843:	 function getTCAtypes($table,$rec,$useFieldNameAsKey=0)
- *  896:     function getTCAtypeValue($table,$rec)
+ *  896:	 function getTCAtypeValue($table,$rec)
- *  919:     function getSpecConfParts($str, $defaultExtras)
+ *  919:	 function getSpecConfParts($str, $defaultExtras)
- *  950:     function getSpecConfParametersFromArray($pArr)
+ *  950:	 function getSpecConfParametersFromArray($pArr)
- *  978:     function getFlexFormDS($conf,$row,$table,$fieldName='',$WSOL=TRUE)
+ *  978:	 function getFlexFormDS($conf,$row,$table,$fieldName='',$WSOL=TRUE)
  *
- *              SECTION: Caching related
+ *			  SECTION: Caching related
- * 1105:     function storeHash($hash,$data,$ident)
+ * 1105:	 function storeHash($hash,$data,$ident)
- * 1125:     function getHash($hash)
+ * 1125:	 function getHash($hash)
  *
- *              SECTION: TypoScript related
+ *			  SECTION: TypoScript related
- * 1161:     function getPagesTSconfig($id,$rootLine='',$returnPartArray=0)
+ * 1161:	 function getPagesTSconfig($id,$rootLine='',$returnPartArray=0)
- * 1217:     function updatePagesTSconfig($id,$pageTS,$TSconfPrefix,$impParams='')
+ * 1217:	 function updatePagesTSconfig($id,$pageTS,$TSconfPrefix,$impParams='')
- * 1272:     function implodeTSParams($p,$k='')
+ * 1272:	 function implodeTSParams($p,$k='')
  *
- *              SECTION: Users / Groups related
+ *			  SECTION: Users / Groups related
- * 1309:     function getUserNames($fields='username,usergroup,usergroup_cached_list,uid',$where='')
+ * 1309:	 function getUserNames($fields='username,usergroup,usergroup_cached_list,uid',$where='')
- * 1327:     function getGroupNames($fields='title,uid', $where='')
+ * 1327:	 function getGroupNames($fields='title,uid', $where='')
- * 1344:     function getListGroupNames($fields='title,uid')
+ * 1344:	 function getListGroupNames($fields='title,uid')
- * 1363:     function blindUserNames($usernames,$groupArray,$excludeBlindedFlag=0)
+ * 1363:	 function blindUserNames($usernames,$groupArray,$excludeBlindedFlag=0)
- * 1396:     function blindGroupNames($groups,$groupArray,$excludeBlindedFlag=0)
+ * 1396:	 function blindGroupNames($groups,$groupArray,$excludeBlindedFlag=0)
  *
- *              SECTION: Output related
+ *			  SECTION: Output related
- * 1437:     function daysUntil($tstamp)
+ * 1437:	 function daysUntil($tstamp)
- * 1449:     function date($tstamp)
+ * 1449:	 function date($tstamp)
- * 1460:     function datetime($value)
+ * 1460:	 function datetime($value)
- * 1472:     function time($value)
+ * 1472:	 function time($value)
- * 1488:     function calcAge($seconds,$labels = 'min|hrs|days|yrs')
+ * 1488:	 function calcAge($seconds,$labels = 'min|hrs|days|yrs')
- * 1514:     function dateTimeAge($tstamp,$prefix=1,$date='')
+ * 1514:	 function dateTimeAge($tstamp,$prefix=1,$date='')
- * 1532:     function titleAttrib($content='',$hsc=0)
+ * 1532:	 function titleAttrib($content='',$hsc=0)
- * 1545:     function titleAltAttrib($content)
+ * 1545:	 function titleAltAttrib($content)
- * 1569:     function thumbCode($row,$table,$field,$backPath,$thumbScript='',$uploaddir=NULL,$abs=0,$tparams='',$size='')
+ * 1569:	 function thumbCode($row,$table,$field,$backPath,$thumbScript='',$uploaddir=NULL,$abs=0,$tparams='',$size='')
- * 1637:     function getThumbNail($thumbScript,$theFile,$tparams='',$size='')
+ * 1637:	 function getThumbNail($thumbScript,$theFile,$tparams='',$size='')
- * 1654:     function titleAttribForPages($row,$perms_clause='',$includeAttrib=1)
+ * 1654:	 function titleAttribForPages($row,$perms_clause='',$includeAttrib=1)
- * 1716:     function getRecordIconAltText($row,$table='pages')
+ * 1716:	 function getRecordIconAltText($row,$table='pages')
- * 1758:     function getLabelFromItemlist($table,$col,$key)
+ * 1758:	 function getLabelFromItemlist($table,$col,$key)
- * 1784:     function getItemLabel($table,$col,$printAllWrap='')
+ * 1784:	 function getItemLabel($table,$col,$printAllWrap='')
- * 1809:     function getRecordTitle($table,$row,$prep=0)
+ * 1809:	 function getRecordTitle($table,$row,$prep=0)
- * 1847:     function getProcessedValue($table,$col,$value,$fixed_lgd_chars=0,$defaultPassthrough=0,$noRecordLookup=FALSE,$uid=0)
+ * 1847:	 function getProcessedValue($table,$col,$value,$fixed_lgd_chars=0,$defaultPassthrough=0,$noRecordLookup=FALSE,$uid=0)
- * 2009:     function getProcessedValueExtra($table,$fN,$fV,$fixed_lgd_chars=0,$uid=0)
+ * 2009:	 function getProcessedValueExtra($table,$fN,$fV,$fixed_lgd_chars=0,$uid=0)
- * 2033:     function getFileIcon($ext)
+ * 2033:	 function getFileIcon($ext)
- * 2047:     function getCommonSelectFields($table,$prefix='')
+ * 2047:	 function getCommonSelectFields($table,$prefix='')
- * 2090:     function makeConfigForm($configArray,$defaults,$dataPrefix)
+ * 2090:	 function makeConfigForm($configArray,$defaults,$dataPrefix)
  *
- *              SECTION: Backend Modules API functions
+ *			  SECTION: Backend Modules API functions
- * 2165:     function helpTextIcon($table,$field,$BACK_PATH,$force=0)
+ * 2165:	 function helpTextIcon($table,$field,$BACK_PATH,$force=0)
- * 2187:     function helpText($table,$field,$BACK_PATH,$styleAttrib='')
+ * 2187:	 function helpText($table,$field,$BACK_PATH,$styleAttrib='')
- * 2239:     function cshItem($table,$field,$BACK_PATH,$wrap='',$onlyIconMode=FALSE, $styleAttrib='')
+ * 2239:	 function cshItem($table,$field,$BACK_PATH,$wrap='',$onlyIconMode=FALSE, $styleAttrib='')
- * 2277:     function editOnClick($params,$backPath='',$requestUri='')
+ * 2277:	 function editOnClick($params,$backPath='',$requestUri='')
- * 2296:     function viewOnClick($id,$backPath='',$rootLine='',$anchor='',$altUrl='',$additionalGetVars='',$switchFocus=TRUE)
+ * 2296:	 function viewOnClick($id,$backPath='',$rootLine='',$anchor='',$altUrl='',$additionalGetVars='',$switchFocus=TRUE)
- * 2328:     function getModTSconfig($id,$TSref)
+ * 2328:	 function getModTSconfig($id,$TSref)
- * 2349:     function getFuncMenu($mainParams,$elementName,$currentValue,$menuItems,$script='',$addparams='')
+ * 2349:	 function getFuncMenu($mainParams,$elementName,$currentValue,$menuItems,$script='',$addparams='')
- * 2392:     function getFuncCheck($mainParams,$elementName,$currentValue,$script='',$addparams='',$tagParams='')
+ * 2392:	 function getFuncCheck($mainParams,$elementName,$currentValue,$script='',$addparams='',$tagParams='')
- * 2417:     function getFuncInput($mainParams,$elementName,$currentValue,$size=10,$script="",$addparams="")
+ * 2417:	 function getFuncInput($mainParams,$elementName,$currentValue,$size=10,$script="",$addparams="")
- * 2438:     function unsetMenuItems($modTSconfig,$itemArray,$TSref)
+ * 2438:	 function unsetMenuItems($modTSconfig,$itemArray,$TSref)
- * 2461:     function getSetUpdateSignal($set='')
+ * 2461:	 function getSetUpdateSignal($set='')
- * 2512:     function getModuleData($MOD_MENU, $CHANGED_SETTINGS, $modName, $type='', $dontValidateList='', $setDefaultList='')
+ * 2512:	 function getModuleData($MOD_MENU, $CHANGED_SETTINGS, $modName, $type='', $dontValidateList='', $setDefaultList='')
  *
- *              SECTION: Core
+ *			  SECTION: Core
- * 2585:     function compilePreviewKeyword($getVarsStr, $beUserUid, $ttl=172800)
+ * 2585:	 function compilePreviewKeyword($getVarsStr, $beUserUid, $ttl=172800)
- * 2613:     function lockRecords($table='',$uid=0,$pid=0)
+ * 2613:	 function lockRecords($table='',$uid=0,$pid=0)
- * 2642:     function isRecordLocked($table,$uid)
+ * 2642:	 function isRecordLocked($table,$uid)
- * 2682:     function exec_foreign_table_where_query($fieldValue,$field='',$TSconfig=array(),$prefix='')
+ * 2682:	 function exec_foreign_table_where_query($fieldValue,$field='',$TSconfig=array(),$prefix='')
- * 2763:     function getTCEFORM_TSconfig($table,$row)
+ * 2763:	 function getTCEFORM_TSconfig($table,$row)
- * 2814:     function getTSconfig_pidValue($table,$uid,$pid)
+ * 2814:	 function getTSconfig_pidValue($table,$uid,$pid)
- * 2844:     function getPidForModTSconfig($table,$uid,$pid)
+ * 2844:	 function getPidForModTSconfig($table,$uid,$pid)
- * 2860:     function getTSCpid($table,$uid,$pid)
+ * 2860:	 function getTSCpid($table,$uid,$pid)
- * 2876:     function firstDomainRecord($rootLine)
+ * 2876:	 function firstDomainRecord($rootLine)
- * 2898:     function getDomainStartPage($domain, $path='')
+ * 2898:	 function getDomainStartPage($domain, $path='')
- * 2928:     function RTEsetup($RTEprop,$table,$field,$type='')
+ * 2928:	 function RTEsetup($RTEprop,$table,$field,$type='')
- * 2947:     function &RTEgetObj()
+ * 2947:	 function &RTEgetObj()
- * 2986:     function &softRefParserObj($spKey)
+ * 2986:	 function &softRefParserObj($spKey)
- * 3018:     function explodeSoftRefParserList($parserList)
+ * 3018:	 function explodeSoftRefParserList($parserList)
- * 3050:     function isModuleSetInTBE_MODULES($modName)
+ * 3050:	 function isModuleSetInTBE_MODULES($modName)
- * 3073:     function referenceCount($table,$ref,$msg='')
+ * 3073:	 function referenceCount($table,$ref,$msg='')
  *
- *              SECTION: Workspaces / Versioning
+ *			  SECTION: Workspaces / Versioning
- * 3132:     function selectVersionsOfRecord($table, $uid, $fields='*', $workspace=0)
+ * 3132:	 function selectVersionsOfRecord($table, $uid, $fields='*', $workspace=0)
- * 3180:     function fixVersioningPid($table,&$rr,$ignoreWorkspaceMatch=FALSE)
+ * 3180:	 function fixVersioningPid($table,&$rr,$ignoreWorkspaceMatch=FALSE)
- * 3220:     function workspaceOL($table,&$row,$wsid=-99)
+ * 3220:	 function workspaceOL($table,&$row,$wsid=-99)
- * 3268:     function getWorkspaceVersionOfRecord($workspace, $table, $uid, $fields='*')
+ * 3268:	 function getWorkspaceVersionOfRecord($workspace, $table, $uid, $fields='*')
- * 3297:     function getLiveVersionOfRecord($table,$uid,$fields='*')
+ * 3297:	 function getLiveVersionOfRecord($table,$uid,$fields='*')
- * 3319:     function isPidInVersionizedBranch($pid, $table='',$returnStage=FALSE)
+ * 3319:	 function isPidInVersionizedBranch($pid, $table='',$returnStage=FALSE)
- * 3342:     function versioningPlaceholderClause($table)
+ * 3342:	 function versioningPlaceholderClause($table)
- * 3356:     function countVersionsOfRecordsOnPage($workspace,$pageId, $allTables=FALSE)
+ * 3356:	 function countVersionsOfRecordsOnPage($workspace,$pageId, $allTables=FALSE)
- * 3391:     function wsMapId($table,$uid)
+ * 3391:	 function wsMapId($table,$uid)
  *
- *              SECTION: Miscellaneous
+ *			  SECTION: Miscellaneous
- * 3421:     function typo3PrintError($header,$text,$js='',$head=1)
+ * 3421:	 function typo3PrintError($header,$text,$js='',$head=1)
- * 3465:     function TYPO3_copyRightNotice()
+ * 3465:	 function TYPO3_copyRightNotice()
- * 3489:     function displayWarningMessages()
+ * 3489:	 function displayWarningMessages()
- * 3546:     function getPathType_web_nonweb($path)
+ * 3546:	 function getPathType_web_nonweb($path)
- * 3558:     function ADMCMD_previewCmds($pageinfo)
+ * 3558:	 function ADMCMD_previewCmds($pageinfo)
- * 3580:     function processParams($params)
+ * 3580:	 function processParams($params)
- * 3606:     function getListOfBackendModules($name,$perms_clause,$backPath='',$script='index.php')
+ * 3606:	 function getListOfBackendModules($name,$perms_clause,$backPath='',$script='index.php')
  *
  * TOTAL FUNCTIONS: 99
  * (This index is automatically created/updated by the extension "extdeveval")
@@ -172,7 +172,6 @@
  */
 
 
-
 /**
  * Standard functions available for the TYPO3 backend.
  * Don't instantiate - call functions with "t3lib_BEfunc::" prefixed the function name.
@@ -184,7 +183,6 @@
 final class t3lib_BEfunc {
 
 
-
 	/*******************************************
 	 *
 	 * SQL-related, selecting records, searching
@@ -202,10 +200,10 @@
 	 * @param	string		Table alias if any
 	 * @return	string		WHERE clause for filtering out deleted records, eg " AND tablename.deleted=0"
 	 */
-	public static function deleteClause($table,$tableAlias = '') {
+	public static function deleteClause($table, $tableAlias = '') {
 		global $TCA;
 		if ($TCA[$table]['ctrl']['delete']) {
-			return ' AND '.($tableAlias ? $tableAlias : $table).'.'.$TCA[$table]['ctrl']['delete'].'=0';
+			return ' AND ' . ($tableAlias ? $tableAlias : $table) . '.' . $TCA[$table]['ctrl']['delete'] . '=0';
 		} else {
 			return '';
 		}
@@ -226,12 +224,12 @@
 	 * @param	boolean		Use the deleteClause to check if a record is deleted (default true)
 	 * @return	array		Returns the row if found, otherwise nothing
 	 */
-	public static function getRecord($table, $uid, $fields = '*', $where = '', $useDeleteClause = true) {
+	public static function getRecord($table, $uid, $fields = '*', $where = '', $useDeleteClause = TRUE) {
 		if ($GLOBALS['TCA'][$table]) {
 			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
 				$fields,
 				$table,
-				'uid=' . intval($uid) . ($useDeleteClause ? self::deleteClause($table) : '') . $where
+					'uid=' . intval($uid) . ($useDeleteClause ? self::deleteClause($table) : '') . $where
 			);
 			$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
 			$GLOBALS['TYPO3_DB']->sql_free_result($res);
@@ -251,13 +249,13 @@
 	 * @param	boolean		Use the deleteClause to check if a record is deleted (default true)
 	 * @return	array		Returns the row if found, otherwise nothing
 	 */
-	public static function getRecordWSOL($table, $uid, $fields = '*', $where = '', $useDeleteClause = true) {
+	public static function getRecordWSOL($table, $uid, $fields = '*', $where = '', $useDeleteClause = TRUE) {
 		if ($fields !== '*') {
-			$internalFields = t3lib_div::uniqueList($fields.',uid,pid'.($table == 'pages' ? ',t3ver_swapmode' : ''));
+			$internalFields = t3lib_div::uniqueList($fields . ',uid,pid' . ($table == 'pages' ? ',t3ver_swapmode' : ''));
 			$row = self::getRecord($table, $uid, $internalFields, $where, $useDeleteClause);
 			self::workspaceOL($table, $row);
 
-			if (is_array ($row)) {
+			if (is_array($row)) {
 				foreach (array_keys($row) as $key) {
 					if (!t3lib_div::inList($fields, $key) && $key{0} !== '_') {
 						unset ($row[$key]);
@@ -309,28 +307,30 @@
 	 * @param	boolean		Use the deleteClause to check if a record is deleted (default true)
 	 * @return	mixed		Multidimensional array with selected records (if any is selected)
 	 */
-	public static function getRecordsByField($theTable, $theField, $theValue, $whereClause = '', $groupBy = '', $orderBy = '', $limit = '', $useDeleteClause = true) {
+	public static function getRecordsByField($theTable, $theField, $theValue, $whereClause = '', $groupBy = '', $orderBy = '', $limit = '', $useDeleteClause = TRUE) {
 		global $TCA;
 		if (is_array($TCA[$theTable])) {
 			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
-						'*',
-						$theTable,
+				'*',
+				$theTable,
-						$theField.'='.$GLOBALS['TYPO3_DB']->fullQuoteStr($theValue, $theTable).
+					$theField . '=' . $GLOBALS['TYPO3_DB']->fullQuoteStr($theValue, $theTable) .
-							($useDeleteClause ? self::deleteClause($theTable).' ' : '').
+							($useDeleteClause ? self::deleteClause($theTable) . ' ' : '') .
 							self::versioningPlaceholderClause($theTable) . ' ' .
-							$whereClause,	// whereClauseMightContainGroupOrderBy
+							$whereClause, // whereClauseMightContainGroupOrderBy
-						$groupBy,
-						$orderBy,
-						$limit
-					);
+				$groupBy,
+				$orderBy,
+				$limit
+			);
 			$rows = array();
-			while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
+			while ($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res)) {
 				$rows[] = $row;
 			}
 			$GLOBALS['TYPO3_DB']->sql_free_result($res);
-			if (count($rows))	return $rows;
+			if (count($rows)) {
+				return $rows;
-		}
-	}
+			}
+		}
+	}
 
 	/**
 	 * Returns a WHERE clause which will make an AND search for the words in the $searchWords array in any of the fields in array $fields.
@@ -390,18 +390,20 @@
 	 */
 	public static function getSQLselectableList($in_list, $tablename, $default_tablename) {
 		$list = Array();
-		if ((string)trim($in_list)!='') {
+		if ((string) trim($in_list) != '') {
 			$tempItemArray = explode(',', trim($in_list));
 			foreach ($tempItemArray as $key => $val) {
 				$val = strrev($val);
 				$parts = explode('_', $val, 2);
-				if ((string)trim($parts[0])!='') {
+				if ((string) trim($parts[0]) != '') {
 					$theID = intval(strrev($parts[0]));
 					$theTable = trim($parts[1]) ? strrev(trim($parts[1])) : $default_tablename;
-					if ($theTable==$tablename)	{$list[] = $theID;}
+					if ($theTable == $tablename) {
+						$list[] = $theID;
-				}
-			}
-		}
+					}
+				}
+			}
+		}
 		return implode(',', $list);
 	}
 
@@ -423,19 +425,19 @@
 		if (is_array($ctrl)) {
 			if (is_array($ctrl['enablecolumns'])) {
 				if ($ctrl['enablecolumns']['disabled']) {
-					$field = $table.'.'.$ctrl['enablecolumns']['disabled'];
+					$field = $table . '.' . $ctrl['enablecolumns']['disabled'];
-					$query[] = $field.'=0';
+					$query[] = $field . '=0';
-					$invQuery[] = $field.'!=0';
+					$invQuery[] = $field . '!=0';
 				}
 				if ($ctrl['enablecolumns']['starttime']) {
-					$field = $table.'.'.$ctrl['enablecolumns']['starttime'];
+					$field = $table . '.' . $ctrl['enablecolumns']['starttime'];
-					$query[] = '('.$field.'<='.$GLOBALS['SIM_ACCESS_TIME'].')';
+					$query[] = '(' . $field . '<=' . $GLOBALS['SIM_ACCESS_TIME'] . ')';
-					$invQuery[] = '('.$field.'!=0 AND '.$field.'>'.$GLOBALS['SIM_ACCESS_TIME'].')';
+					$invQuery[] = '(' . $field . '!=0 AND ' . $field . '>' . $GLOBALS['SIM_ACCESS_TIME'] . ')';
 				}
 				if ($ctrl['enablecolumns']['endtime']) {
-					$field = $table.'.'.$ctrl['enablecolumns']['endtime'];
+					$field = $table . '.' . $ctrl['enablecolumns']['endtime'];
-					$query[] = '('.$field.'=0 OR '.$field.'>'.$GLOBALS['SIM_ACCESS_TIME'].')';
+					$query[] = '(' . $field . '=0 OR ' . $field . '>' . $GLOBALS['SIM_ACCESS_TIME'] . ')';
-					$invQuery[] = '('.$field.'!=0 AND '.$field.'<='.$GLOBALS['SIM_ACCESS_TIME'].')';
+					$invQuery[] = '(' . $field . '!=0 AND ' . $field . '<=' . $GLOBALS['SIM_ACCESS_TIME'] . ')';
 				}
 			}
 		}
@@ -454,14 +456,14 @@
 	 * @return	mixed		Multidimensional array with selected records; if none exist, false is returned
 	 */
 	public static function getRecordLocalization($table, $uid, $language, $andWhereClause = '') {
-		$recordLocalization = false;
+		$recordLocalization = FALSE;
 		if (self::isTableLocalizable($table)) {
 			$tcaCtrl = $GLOBALS['TCA'][$table]['ctrl'];
 			$recordLocalization = self::getRecordsByField(
 				$table,
 				$tcaCtrl['transOrigPointerField'],
 				$uid,
-				'AND '.$tcaCtrl['languageField'].'='.intval($language).($andWhereClause ? ' '.$andWhereClause : ''),
+					'AND ' . $tcaCtrl['languageField'] . '=' . intval($language) . ($andWhereClause ? ' ' . $andWhereClause : ''),
 				'',
 				'',
 				'1'
@@ -471,14 +473,6 @@
 	}
 
 
-
-
-
-
-
-
-
-
 	/*******************************************
 	 *
 	 * SQL-related, DEPRECATED functions
@@ -509,14 +503,14 @@
 		t3lib_div::logDeprecatedFunction();
 
 		$query = $GLOBALS['TYPO3_DB']->SELECTquery(
-					$select,
+			$select,
-					$local_table.','.$mm_table.($foreign_table?','.$foreign_table:''),
+				$local_table . ',' . $mm_table . ($foreign_table ? ',' . $foreign_table : ''),
-					$local_table.'.uid='.$mm_table.'.uid_local'.($foreign_table?' AND '.$foreign_table.'.uid='.$mm_table.'.uid_foreign':'').' '.
+				$local_table . '.uid=' . $mm_table . '.uid_local' . ($foreign_table ? ' AND ' . $foreign_table . '.uid=' . $mm_table . '.uid_foreign' : '') . ' ' .
-						$whereClause,	// whereClauseMightContainGroupOrderBy
+						$whereClause, // whereClauseMightContainGroupOrderBy
-					$groupBy,
-					$orderBy,
-					$limit
-				);
+			$groupBy,
+			$orderBy,
+			$limit
+		);
 		return $query;
 	}
 
@@ -552,14 +546,6 @@
 	}
 
 
-
-
-
-
-
-
-
-
 	/*******************************************
 	 *
 	 * Page tree, TCA related
@@ -648,9 +634,9 @@
 			$res = $GLOBALS['TYPO3_DB']->exec_SELECTquery(
 				'pid,uid,title,TSconfig,is_siteroot,storage_pid,t3ver_oid,t3ver_wsid,t3ver_state,t3ver_swapmode,t3ver_stage,be_layout',
 				'pages',
-				'uid=' . intval($uid) . ' ' .
-					self::deleteClause('pages') . ' ' .
+					'uid=' . intval($uid) . ' ' .
+							self::deleteClause('pages') . ' ' .
-					$clause		// whereClauseMightContainGroupOrderBy
+							$clause // whereClauseMightContainGroupOrderBy
 			);
 
 			$row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res);
@@ -691,7 +677,7 @@
 			// First, find out what mount index to use (if more than one DB mount exists):
 		$mountIndex = 0;
 		$mountKeys = array_flip($BE_USER->returnWebmounts());
-		foreach($rL as $rLDat) {
+		foreach ($rL as $rLDat) {
 			if (isset($mountKeys[$rLDat['uid']])) {
 				$mountIndex = $mountKeys[$rLDat['uid']];
 				break;
@@ -699,7 +685,7 @@
 		}
 
 			// Traverse rootline and open paths:
-		foreach($rL as $rLDat) {
+		foreach ($rL as $rLDat) {
 			$expandedPages[$mountIndex][$rLDat['uid']] = 1;
 		}
 
@@ -721,7 +707,9 @@
 	 * @return	mixed		Path of record (string) OR array with short/long title if $fullTitleLimit is set.
 	 */
 	public static function getRecordPath($uid, $clause, $titleLimit, $fullTitleLimit = 0) {
-		if (!$titleLimit) { $titleLimit = 1000; }
+		if (!$titleLimit) {
+			$titleLimit = 1000;
+		}
 
 		$loopCheck = 100;
 		$output = $fullOutput = '/';
@@ -736,8 +724,8 @@
 			if ($record['uid'] === 0) {
 				continue;
 			}
-			if ($record['_ORIG_pid'] && $record['t3ver_swapmode'] > 0) {		// Branch points
+			if ($record['_ORIG_pid'] && $record['t3ver_swapmode'] > 0) { // Branch points
-				$output = ' [#VEP#]' . $output;		// Adding visual token - Versioning Entry Point - that tells that THIS position was where the versionized branch got connected to the main tree. I will have to find a better name or something...
+				$output = ' [#VEP#]' . $output; // Adding visual token - Versioning Entry Point - that tells that THIS position was where the versionized branch got connected to the main tree. I will have to find a better name or something...
 			}
 			$output = '/' . t3lib_div::fixed_lgd_cs(strip_tags($record['title']), $titleLimit) . $output;
 			if ($fullTitleLimit) {
@@ -764,18 +752,18 @@
 			// All TCA keys:
 		$theExcludeArray = Array();
 		$tc_keys = array_keys($TCA);
-		foreach($tc_keys as $table) {
+		foreach ($tc_keys as $table) {
 				// Load table
 			t3lib_div::loadTCA($table);
 				// All field names configured:
 			if (is_array($TCA[$table]['columns'])) {
 				$f_keys = array_keys($TCA[$table]['columns']);
-				foreach($f_keys as $field) {
+				foreach ($f_keys as $field) {
 					if ($TCA[$table]['columns'][$field]['exclude']) {
 							// Get Human Readable names of fields and table:
-						$Fname = $GLOBALS['LANG']->sl($TCA[$table]['ctrl']['title']).': '.$GLOBALS['LANG']->sl($TCA[$table]['columns'][$field]['label']);
+						$Fname = $GLOBALS['LANG']->sl($TCA[$table]['ctrl']['title']) . ': ' . $GLOBALS['LANG']->sl($TCA[$table]['columns'][$field]['label']);
 							// add entry:
-						$theExcludeArray[] = Array($Fname, $table.':'.$field);
+						$theExcludeArray[] = Array($Fname, $table . ':' . $field);
 					}
 				}
 			}
@@ -834,7 +822,7 @@
 			// All TCA keys:
 		$allowDenyOptions = Array();
 		$tc_keys = array_keys($TCA);
-		foreach($tc_keys as $table)	{
+		foreach ($tc_keys as $table) {
 
 				// Load table
 			t3lib_div::loadTCA($table);
@@ -842,40 +830,40 @@
 				// All field names configured:
 			if (is_array($TCA[$table]['columns'])) {
 				$f_keys = array_keys($TCA[$table]['columns']);
-				foreach($f_keys as $field) {
+				foreach ($f_keys as $field) {
 					$fCfg = $TCA[$table]['columns'][$field]['config'];
-					if ($fCfg['type']=='select' && $fCfg['authMode'])	{
+					if ($fCfg['type'] == 'select' && $fCfg['authMode']) {
 
 							// Check for items:
 						if (is_array($fCfg['items'])) {
 								// Get Human Readable names of fields and table:
-							$allowDenyOptions[$table.':'.$field]['tableFieldLabel'] = $GLOBALS['LANG']->sl($TCA[$table]['ctrl']['title']).': '.$GLOBALS['LANG']->sl($TCA[$table]['columns'][$field]['label']);
+							$allowDenyOptions[$table . ':' . $field]['tableFieldLabel'] = $GLOBALS['LANG']->sl($TCA[$table]['ctrl']['title']) . ': ' . $GLOBALS['LANG']->sl($TCA[$table]['columns'][$field]['label']);
 
 								// Check for items:
-							foreach($fCfg['items'] as $iVal) {
+							foreach ($fCfg['items'] as $iVal) {
-								if (strcmp($iVal[1], ''))	{	// Values '' is not controlled by this setting.
+								if (strcmp($iVal[1], '')) { // Values '' is not controlled by this setting.
 
 										// Find iMode:
 									$iMode = '';
-									switch((string)$fCfg['authMode']) {
+									switch ((string) $fCfg['authMode']) {
 										case 'explicitAllow':
 											$iMode = 'ALLOW';
-										break;
+											break;
 										case 'explicitDeny':
 											$iMode = 'DENY';
-										break;
+											break;
 										case 'individual':
 											if (!strcmp($iVal[4], 'EXPL_ALLOW')) {
 												$iMode = 'ALLOW';
 											} elseif (!strcmp($iVal[4], 'EXPL_DENY')) {
 												$iMode = 'DENY';
 											}
-										break;
+											break;
 									}
 
 										// Set iMode:
 									if ($iMode) {
-										$allowDenyOptions[$table.':'.$field]['items'][$iVal[1]] = array($iMode, $GLOBALS['LANG']->sl($iVal[0]), $adLabel[$iMode]);
+										$allowDenyOptions[$table . ':' . $field]['items'][$iVal[1]] = array($iMode, $GLOBALS['LANG']->sl($iVal[0]), $adLabel[$iMode]);
 									}
 								}
 							}
@@ -898,11 +886,11 @@
 	 *
 	 * @return	array		Array with languages (title, uid, flagIcon)
 	 */
-	public static function getSystemLanguages()	{
+	public static function getSystemLanguages() {
 		$languages = t3lib_div::makeInstance('t3lib_transl8tools')->getSystemLanguages();
 		$sysLanguages = array();
 		foreach ($languages as $language) {
-			if($language['uid'] !== -1) {
+			if ($language['uid'] !== -1) {
 				$sysLanguages[] = array(
 					0 => htmlspecialchars($language['title']) . ' [' . $language['uid'] . ']',
 					1 => $language['uid'],
